﻿
Imports System.Data.OleDb

Public Class FTestDB

    Dim MiConexion As New OleDbConnection
    Dim MisDatos As New DataSet
    Dim NombreTablaEnDB As String
    Dim MiComando As New OleDbCommand

    Dim NombreDataTablaCiudadesConPais As String = "TodasCiudades"
    Dim NombreDataTablaPaises As String = "TodosPaises"
    Dim NombreDataTablaCiudadesDelPais As String = "CiudadesDelPaises"

    Dim CargarPaisCompleto As Boolean = False   ' Para evitar los procedimientos que dan errores si activados durante la carga.

    Private Sub FTestDB_Load(sender As Object, e As EventArgs) Handles Me.Load
        '
    End Sub

    Private Sub FTestDB_FormClosed(sender As Object, e As FormClosedEventArgs) Handles Me.FormClosed
        Try
            MisDatos.Dispose()
        Catch ex As Exception

        End Try
    End Sub

    Private Sub PrepararConexion()   ' es necesario de cambiar la RutaYNombreDB segun el sistema (disco, carpeta)

        Dim RutaYNombreDB As String = "D:\Tmp\TestAccesDBSimpleConMostrarPaisCiudad\PaisCiudades.accdb"
        MiConexion.ConnectionString = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & RutaYNombreDB & ";"  ' Ejecutar en x64

    End Sub

    Private Sub BCargarDGVConAdapter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BCargarDGVConAdapter.Click
        LlenarConAdapter()
    End Sub

    Private Sub BCargarPaises_Click(sender As Object, e As EventArgs) Handles BCargarPaises.Click
        LlenarCBPaises()
    End Sub

    Private Sub LlenarConAdapter() ' con DataAdapter es simple porque la DataTabla es creada automaticamente

        If MisDatos.Tables.Count > 0 Then  ' Para muchas pruebas
            Try
                MisDatos.Tables.Remove(NombreDataTablaCiudadesConPais)
            Catch
            End Try
        End If

        PrepararConexion()

        Dim UnaTabla As New DataTable
        Dim Consulta As String

        Consulta =
"SELECT IdCiudad, NombreCiudad, NombrePais
FROM TCiudades INNER JOIN TPaises ON TCiudades.IdPaisDeEstaCiudad = TPaises.IdPais
ORDER BY NombrePais, NombreCiudad;"

        Dim MiAdapter As OleDbDataAdapter = New OleDbDataAdapter(Consulta, MiConexion)

        MiAdapter.Fill(UnaTabla)
        UnaTabla.TableName = NombreDataTablaCiudadesConPais
        MisDatos.Tables.Add(UnaTabla)

        MiAdapter.Dispose()
        MiConexion.Close()

        ' Mostrar en DataGridView
        DGVCiudadesconPaises.DataSource = MisDatos.Tables(NombreDataTablaCiudadesConPais)

    End Sub

    Private Sub LlenarCBPaises()
        If MisDatos.Tables.Count > 0 Then  ' Para muchas pruebas
            Try
                MisDatos.Tables.Remove(NombreDataTablaPaises)
            Catch
            End Try
        End If

        PrepararConexion()

        Dim UnaTabla As New DataTable
        Dim Consulta As String

        Consulta =
        "SELECT * FROM TPaises ORDER BY NombrePais;"

        Dim MiAdapter As OleDbDataAdapter = New OleDbDataAdapter(Consulta, MiConexion)

        MiAdapter.Fill(UnaTabla)
        UnaTabla.TableName = NombreDataTablaPaises
        MisDatos.Tables.Add(UnaTabla)

        MiAdapter.Dispose()
        MiConexion.Close()

        ' Mostrar en CB Paises
        CBPaises.DataSource = MisDatos.Tables(NombreDataTablaPaises)
        CBPaises.DisplayMember = "NombrePais"
        CBPaises.ValueMember = "IdPais"

        CargarPaisCompleto = True
        LlenarCBCiudades()
    End Sub

    Private Sub CBPaises_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CBPaises.SelectedIndexChanged
        If Not CargarPaisCompleto Then
            Exit Sub
        End If
        LlenarCBCiudades()
    End Sub

    Private Sub LlenarCBCiudades()
        If MisDatos.Tables.Count > 0 Then  ' Para muchas pruebas
            Try
                MisDatos.Tables.Remove(NombreDataTablaCiudadesDelPais)
            Catch
            End Try
        End If

        PrepararConexion()

        Dim UnaTabla As New DataTable
        Dim Consulta As String

        Consulta =
        "SELECT * FROM TCiudades WHERE IdPaisDeEstaCiudad = " & CBPaises.SelectedValue & " ORDER BY NombreCiudad;"

        Dim MiAdapter As OleDbDataAdapter = New OleDbDataAdapter(Consulta, MiConexion)

        MiAdapter.Fill(UnaTabla)
        UnaTabla.TableName = NombreDataTablaCiudadesDelPais
        MisDatos.Tables.Add(UnaTabla)

        MiAdapter.Dispose()
        MiConexion.Close()

        ' Mostrar en CB Ciudades
        CBCiudades.DataSource = MisDatos.Tables(NombreDataTablaCiudadesDelPais)
        CBCiudades.DisplayMember = "NombreCiudad"
        '  CBCiudades.ValueMember = "IdCiudad"  '' No util en este ejemplo
    End Sub

End Class

